import { pJSOptions, pJSContainerInteractivity, pJSSvg, pJSImg, pJSBubble, pJSRepulse } from './pjsinterfaces';
import { pJSRetina } from './pjsretina';
import { pJSCanvas } from './pjscanvas';
import { pJSParticles } from './pjsparticles';
import { pJSProcessBubbleType } from './pjsenums';
import { pJSParticle } from './pjsparticle';
export declare class pJSContainer {
    interactivity: pJSContainerInteractivity;
    options: pJSOptions;
    retina: pJSRetina;
    canvas: pJSCanvas;
    particles: pJSParticles;
    checkAnimFrame?: number;
    drawAnimFrame?: number;
    bubble: pJSBubble;
    repulse: pJSRepulse;
    svg: pJSSvg;
    img: pJSImg;
    lastFrameTime: number;
    pageHidden: boolean;
    constructor(tag_id: string, params: pJSOptions);
    handleVisibilityChange(): void;
    eventsListeners(): void;
    densityAutoParticles(): void;
    destroypJS(): void;
    exportImg(): void;
    loadImg(type: string): Promise<void>;
    requestFrame(callback: FrameRequestCallback): number;
    cancelAnimation(handle: number): void;
    draw(timestamp: DOMHighResTimeStamp): void;
    checkBeforeDraw(): void;
    processBubble(p: pJSParticle, dist_mouse: number, time_spent: number, bubble_param: number, particles_param: number, p_obj_bubble: number | undefined, p_obj: number, id: pJSProcessBubbleType): void;
    init(): void;
    start(): Promise<void>;
}
