import { pJSParticleImage, pJSColor, pJSCoordinates } from './pjsinterfaces';
import { pJSContainer } from './pjscontainer';
import { pJSShapeType } from './pjsenums';
export declare class pJSParticle {
    pJSContainer: pJSContainer;
    radius: number;
    size_status?: boolean;
    vs?: number;
    x: number;
    y: number;
    offsetX: number;
    offsetY: number;
    color: pJSColor;
    opacity: number;
    opacity_status?: boolean;
    vo?: number;
    vx: number;
    vy: number;
    vx_i: number;
    vy_i: number;
    shape?: pJSShapeType;
    img?: pJSParticleImage;
    radius_bubble?: number;
    opacity_bubble?: number;
    text?: string;
    constructor(pJSContainer: pJSContainer, color: {
        value: string[] | pJSColor | string;
    }, opacity: number, position?: pJSCoordinates);
    draw(): void;
    subDraw(ctx: CanvasRenderingContext2D, img_obj: HTMLImageElement, radius: number): void;
    drawShape(ctx: CanvasRenderingContext2D, startX: number, startY: number, sideLength: number, sideCountNumerator: number, sideCountDenominator: number): void;
    checkOverlap(position?: pJSCoordinates): void;
    createSvgImg(): void;
    initBubble(): void;
    grab(): void;
    bubble(): void;
    repulse(): void;
    processRepulse(dx: number, dy: number, force: number): void;
    link(p2: pJSParticle): void;
    attract(p2: pJSParticle): void;
    bounce(p2: pJSParticle): void;
}
